> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.brevo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.brevo.com/_mcp/server.

# Get Transaction History API

GET https://api.brevo.com/v3/loyalty/balance/programs/{pid}/transaction-history

Returns transaction history

Reference: https://developers.brevo.com/reference/get-transaction-history-api

## Authentication

- `api-key` header (required) — The API key should be passed in the request headers as `api-key` for authentication.

## Request

### Path parameters

- `pid` (string, required) — Loyalty Program Id

### Query parameters

- `limit` (integer, optional) — Limit the number of records returned
- `offset` (integer, optional) — Page number to retrieve
- `sortField` (enum, optional, default: createdAt) — Field to sort by
  - Allowed values: `createdAt`
- `sort` (enum, optional) — Sort order
  - Allowed values: `asc`, `desc`
- `contactId` (long, required) — Contact ID
- `balanceDefinitionId` (string, required) — Balance Definition ID
- `status` (enum, optional) — Transaction status filter
  - Allowed values: `draft`, `completed`, `rejected`, `cancelled`, `expired`
- `transactionType` (enum, optional) — Transaction type filter
  - Allowed values: `credit`, `debit`
- `loyaltySubscriptionId` (string, optional) — Loyalty Subscription ID filter

## Response

### 200

Successful retrieval of transaction history

- `balanceDefinitionId` (string, optional) — Unique identifier of the associated balance definition.
- `contactId` (integer, optional) — Unique identifier of the contact related to the transactions.
- `count` (integer, optional) — Total number of transactions in the history.
- `loyaltyProgramId` (string, optional) — Unique identifier of the associated loyalty program.
- `transactionHistory` (list of object, optional) — List of past transactions associated with the balance.
  - `amount` (float, optional) — The transaction amount.
  - `transactionType` (enum, optional) — The type of the transaction.
    - Allowed values: `credit`, `debit`
  - `balanceExpirationDate` (string, optional) — Expiration date of the balance associated with this transaction.
  - `cancelledAt` (string, optional) — Timestamp when the transaction was canceled, if applicable.
  - `completedAt` (string, optional) — Timestamp when the transaction was successfully completed.
  - `createdAt` (string, optional) — Timestamp when the transaction was initiated.
  - `id` (string, optional) — Unique identifier of the transaction.
  - `meta` (map from string to any, optional) — Optional metadata associated with the transaction.
  - `rejectReason` (string, optional) — Reason for rejection, if the transaction was declined.
  - `rejectedAt` (string, optional) — Timestamp when the transaction was rejected.
  - `status` (string, optional) — Current status of the transaction (e.g., pending, completed, rejected).

## Errors

### 401 Unauthorized Error

Request Authentication Failed

- `message` (string, required) — Readable message associated to the failure
- `code` (string, optional) — Error code displayed in case of a failure

### 403 Forbidden Error

Cannot Authenticate Request

- `message` (string, required) — Readable message associated to the failure
- `code` (string, optional) — Error code displayed in case of a failure

### 404 Not Found Error

subscription not found

- `message` (string, required) — Readable message associated to the failure
- `code` (string, optional) — Error code displayed in case of a failure

### 422 Unprocessable Entity Error

Validation errors

- `message` (string, required) — Readable message associated to the failure
- `code` (string, optional) — Error code displayed in case of a failure

### 500 Internal Server Error

Internal error occurred

- `message` (string, required) — Readable message associated to the failure
- `code` (string, optional) — Error code displayed in case of a failure

## Examples

**Response**

```json
{
  "balanceDefinitionId": "string",
  "contactId": 1,
  "count": 1,
  "loyaltyProgramId": "string",
  "transactionHistory": [
    {
      "amount": 1.1,
      "transactionType": "credit",
      "balanceExpirationDate": "string",
      "cancelledAt": "string",
      "completedAt": "string",
      "createdAt": "string",
      "id": "string",
      "meta": {},
      "rejectReason": "string",
      "rejectedAt": "string",
      "status": "string"
    }
  ]
}
```

**SDK Code**

```typescript
import { BrevoClient } from "@getbrevo/brevo";

async function main() {
    const client = new BrevoClient({
        apiKey: "YOUR_API_KEY_HERE",
    });
    await client.balance.getTransactionHistoryApi({
        pid: "pid",
        balanceDefinitionId: "balanceDefinitionId",
        contactId: 1,
    });
}
main();

```

```python
from brevo import Brevo

client = Brevo(
    api_key="YOUR_API_KEY_HERE",
)

client.balance.get_transaction_history_api(
    pid="pid",
    balance_definition_id="balanceDefinitionId",
    contact_id=1,
)

```

```php
<?php

namespace Example;

use Brevo\Brevo;
use Brevo\Balance\Requests\GetLoyaltyBalanceProgramsPidTransactionHistoryRequest;

$client = new Brevo(
    apiKey: 'YOUR_API_KEY_HERE',
);
$client->balance->getTransactionHistoryApi(
    'pid',
    new GetLoyaltyBalanceProgramsPidTransactionHistoryRequest([
        'balanceDefinitionId' => 'balanceDefinitionId',
        'contactId' => 1,
    ]),
);

```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.brevo.com/v3/loyalty/balance/programs/pid/transaction-history?balanceDefinitionId=balanceDefinitionId&contactId=1"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.brevo.com/v3/loyalty/balance/programs/pid/transaction-history?balanceDefinitionId=balanceDefinitionId&contactId=1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.brevo.com/v3/loyalty/balance/programs/pid/transaction-history?balanceDefinitionId=balanceDefinitionId&contactId=1")
  .header("api-key", "<apiKey>")
  .asString();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.brevo.com/v3/loyalty/balance/programs/pid/transaction-history?balanceDefinitionId=balanceDefinitionId&contactId=1");
var request = new RestRequest(Method.GET);
request.AddHeader("api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.brevo.com/v3/loyalty/balance/programs/pid/transaction-history?balanceDefinitionId=balanceDefinitionId&contactId=1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```